package nl.amis.annotation;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.Iterator;
import java.util.SortedMap;
import java.util.TreeMap;
import nl.amis.annotation.descriptor.Descriptor;

public class AnnotatedObject {

    public String toString() {
        String tostring = "";
        Method[] methods = this.getClass().getDeclaredMethods();
        SortedMap descriptors = new TreeMap();
        for (Method m: methods) {
            Descriptor annotation = m.getAnnotation(Descriptor.class);
            if (annotation == null) {
                continue;
            }
            Object[] args = null;
            try {
                descriptors.put(new Integer(annotation.sequence())
                    , annotation.label() + " " + m.invoke(this, args));
            } catch (InvocationTargetException ite) {
            } catch (IllegalAccessException iae) {
            }
        }
        // if no annotated methods were found, fall back on the default toString implementation
        if (descriptors.isEmpty()) {
            tostring = super.toString();
        } else {
            Iterator<String> descriptorIterator = 
                descriptors.values().iterator();
            while (descriptorIterator.hasNext()) {
                tostring = tostring + ";" + descriptorIterator.next();
            }
        }
        return tostring.substring(1);
    }

}
